!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Trees</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Trees</h1>    
                    </section>
                    <section>
                        <h2>Trees Overview</h2>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                    </section>
                </section>
                <!-- Coding Style Guide Section -->
                <section>   
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
						<h2>Tree Data Structure</h2>
						<p>The code to write a tree node would be similar to what is given below. It has a data part and references to its left and right child nodes.</p>
						<pre>
							<code data-trim data-noescape>
								struct node {
									int data;   
									struct node *leftChild;
									struct node *rightChild;
								 };
							</code>
						</pre>

						
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>
					<section>
						<h2>Important Terms</h2>
						<ul>
							<li>Path − Path refers to the sequence of nodes along the edges of a tree.</li>

							<li>Root − The node at the top of the tree is called root. There is only one root per tree and one path from the root node to any node.</li>

							<li>Parent − Any node except the root node has one edge upward to a node called parent.</li>

							<li>Child − The node below a given node connected by its edge downward is called its child node.</li>
						</ul>
					</section>
					<section>
						<h2>Important Terms</h2>
						<ul>
							<li>Child − The node below a given node connected by its edge downward is called its child node.</li>

							<li>Leaf − The node which does not have any child node is called the leaf node.</li>

							<li>Subtree − Subtree represents the descendants of a node.</li>

						</ul>
					</section>
					<section>
						<h2>Important Terms</h2>
						<ul>
							<li>Traversing − Traversing means passing through nodes in a specific order.</li>

							<li>Levels − Level of a node represents the generation of a node. If the root node is at level 0,
								then its next child node is at level 1, its grandchild is at level 2, and so on.</li>

							<li>keys − Key represents a value of a node based on which a search operation is to be carried out for a node.</li>

						</ul>
					</section>
					<section>
						<h3>Tree basic structure</h3>
						<img src="../../../assets/tree1.jpg" alt="tree1">
					</section>
                </section>
                <!-- Arrays Section -->
                <section>
                    <section>
                        <h2>Binary Search Tree</h2>
						<img src="../../../assets/tree2.jpg" alt="tree2">
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Binary Search Tree Operations</h2>
						<ul>
							<li>Insert − Inserts an element in a tree/create a tree.</li>

							<li>Search − Searches an element in a tree.</li>

							<li>Preorder Traversal − Traverses a tree in a pre-order manner.</li>

							<li>Inorder Traversal − Traverses a tree in an in-order manner.</li>

							<li>Postorder Traversal − Traverses a tree in a post-order manner.</li>
						</ul>
					</section>
					
                </section>
                <!-- Access & Modify Arrays Section -->
                <section>
                    <section>
						<h2>Insert Operations</h2>
						<p>Algorithm</p>
						
						<pre>
							<code data-trim data-noescape>
								If root is NULL 
									then create root node
								return

								If root exists then
									compare the data with node.data
									
								while until insertion position is located

										If data is greater than node.data
											goto right subtree
										else
											goto left subtree

								endwhile 
									
								insert data
										
								end If  
							</code>
						</pre>

						
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h2>Search Operations</h2>
						<p>Algorithm</p>
						
						<pre>
							<code data-trim data-noescape>
								If root.data is equal to search.data
									return root
								else
									while data not found

										If data is greater than node.data
											goto right subtree
										else
											goto left subtree
											
										If data found
											return node
									endwhile 
									
									return data not found
									
								end if  
							</code>
						</pre>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Search operation </h2>
						<pre>
							<code data-trim data-noescape>
								struct node* search(struct node *root, int x)
								{
									if(root==NULL || root->data==x)
										return root;
									else if(x>root->data)
										return search(root->right_child, x);
									else
										return search(root->left_child,x);
								}
							</code>
						</pre>
					</section>
					<section>
						<h2>Insert operation </h2>
						<pre>
							<code data-trim data-noescape>
								struct node* insert(struct node *root, int x)
								{
									if(root==NULL)
										return new_node(x);
									else if(x>root->data)
										root->right_child = insert(root->right_child, x);
									else
										root->left_child = insert(root->left_child,x);
									return root;
								}
							</code>
						</pre>
                    </section>
                </section>
                <!-- Strings Section -->
                <section>
                    <section>
						<h2>Traversals</h2>
						<p>DFS -> Depth-First Search</p>
							<ul>
								<li>In-order traversal</li>
								<li>Pre-order traversal</li>
								<li>Post-order traversal</li>
						
							</ul>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>In-Order Traversal</h2>
						<img src="../../../assets/tree3.jpg" alt="tree3">
						<p>D → B → E → A → F → C → G</p>
					</section>
					<section>
						<h3>In-Order Algorithm</h3>
						<pre>
							<code data-trim data-noescape>
								Until all nodes are traversed −
								Step 1 − Recursively traverse left subtree.
								Step 2 − Visit root node.
								Step 3 − Recursively traverse right subtree.
							</code>
						</pre>
					</section>
					<section>
						<h2>Pre-Order Traversal</h2>
						<img src="../../../assets/tree4.jpg" alt="tree4">
						<p>A → B → D → E → C → F → G</p>
					</section>
					<section>
						<h3>Pre-Order Algorithm</h3>
						<pre>
							<code data-trim data-noescape>
								Until all nodes are traversed −
								Step 1 − Visit root node.
								Step 2 − Recursively traverse left subtree.
								Step 3 − Recursively traverse right subtree.
							</code>
						</pre>
					</section>
					<section>
						<h2>Post-Order Traversal</h2>
						<img src="../../../assets/tree5.jpg" alt="tree5">
						<p>D → E → B → F → G → C → A</p>
					</section>
					<section>
						<h3>Post-Order Algorithm</h3>
						<pre>
							<code data-trim data-noescape>
								Until all nodes are traversed −
								Step 1 − Recursively traverse left subtree.
								Step 2 − Recursively traverse right subtree.
								Step 3 − Visit root node.
							</code>
						</pre>
					</section>
                </section>
                <!-- String Methods Section -->
                <section>
                    <section>
                        <h2>Trees Demo</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                  
                </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>List</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>

